import React, { useRef, useState, useCallback } from 'react';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var PinInput = function PinInput(_ref) {
  var length = _ref.length,
      direction = _ref.direction,
      showValues = _ref.showValues,
      onChangePin = _ref.onChangePin,
      PinComponent = _ref.pinComponent,
      PinComponentOnFill = _ref.pinComponentOnFill,
      PinComponentOnFocus = _ref.pinComponentOnFocus,
      PinText = _ref.pinText,
      props = _objectWithoutPropertiesLoose(_ref, ["length", "direction", "showValues", "onChangePin", "pinComponent", "pinComponentOnFill", "pinComponentOnFocus", "pinText"]);

  var inputRef = useRef(null);

  var _useState = useState(''),
      pinValues = _useState[0],
      setPinValues = _useState[1];

  var _useState2 = useState(false),
      isFocused = _useState2[0],
      setIsFocused = _useState2[1];

  var focusInput = useCallback(function () {
    var _inputRef$current;

    (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
  }, []);
  var whichToRender = useCallback(function (index) {
    if (pinValues[index] && PinComponentOnFill) {
      return React.createElement(PinComponentOnFill, null, showValues && PinText && React.createElement(PinText, null, pinValues[index]));
    }

    if (pinValues.length === index && PinComponentOnFocus && isFocused) {
      return React.createElement(PinComponentOnFocus, null);
    }

    if (pinValues.length === length && PinComponentOnFocus && isFocused) {
      return React.createElement(PinComponentOnFocus, null);
    }

    if (pinValues[index] && PinComponentOnFill) {
      return React.createElement(PinComponentOnFill, null, showValues && PinText && React.createElement(PinText, null, pinValues[index]));
    }

    return React.createElement(PinComponent, null);
  }, [PinComponent, PinComponentOnFill, PinComponentOnFocus, pinValues, isFocused, showValues, PinText, length]);
  var handleOnChange = useCallback(function (value) {
    if (onChangePin) {
      onChangePin(value);
    }

    setPinValues(value);
  }, [onChangePin]);
  var onFocus = useCallback(function () {
    setIsFocused(function (oldProps) {
      return !oldProps;
    });
  }, []);
  var onBlur = useCallback(function () {
    setIsFocused(function (oldProps) {
      return !oldProps;
    });
  }, []);
  return React.createElement("div", {
    role: 'input',
    tabIndex: 0,
    onClick: focusInput,
    onKeyDown: focusInput,
    style: {
      display: 'flex',
      flexDirection: direction,
      cursor: 'text',
      width: 'fit-content',
      outline: 'none'
    }
  }, React.createElement("input", Object.assign({
    ref: inputRef
  }, props, {
    onChange: function onChange(e) {
      return handleOnChange(e.target.value);
    },
    maxLength: length,
    style: {
      position: 'absolute',
      opacity: 0,
      width: 0,
      height: 0,
      outline: 'none',
      border: 0
    },
    type: 'password',
    onFocus: onFocus,
    onBlur: onBlur
  })), Array(length).fill('').map(function (_, index) {
    return whichToRender(index);
  }));
};

export { PinInput };
//# sourceMappingURL=index.modern.js.map
